#ifndef PSTD_OPT_H
#define PSTD_OPT_H
#include <malloc.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>
#include <omp.h>
#include <fftw3.h>



typedef struct
{	
	
	int *EUx,*EUy,*EUz,*EVx;
	int PML;
	int nLTx,nLTy,nLTz;

}scenario;

typedef struct
{
	int nFFT;
	scenario s;
	float CteDer,CteDer2,sigma,y,*nu,*tau,*C0,*C1x,*C1y,*C2,*C3,*C4;
	int nx,ny,nz,nx2,ny2,nz2,nPML,nt,Ns,Nr,*intP,N;
	fftwf_complex *Derx, *Der2x, *Dery, *Der2y, *Der3, *Der4,*Der5;
    float *DerRx, *Der2Rx,*DerRy, *Der2Ry, *Der3R;
	fftwf_plan planfordDerx,planbackDerx,planfordDer2x,planbackDer2x,planfordDery,planbackDery,planfordDer2y,planbackDer2y,planfordDer3,planbackDer3,planfordDer4,planbackDer4,planfordDer5,planbackDer5;	
	float *vx,*vy,*vz,*pxn,*pyn,*pzn,*q,*py,*pz,a1,a2,Abs,*PXn,*DtPXn,*PX,*P,*DP,*px,*p,*qn,*qnn,*Dq,*auxX,*auxY;
	float Dx,S,Lx,Ly,Lz,Dt,*source,c,*vel,*rho;
} domain;


void initDerivatives(domain* D);

void source2D(domain* D,int type,int nS,int nR,int t);
void initParam2D(domain* D,float Lx,float Ly,float Dx,float Dt, float S,float tiempo, int nPML,float sigma,float Abs);
void defineDomain2D(domain* D,int type);
void initArrays2D(domain* D);
void initDerivatives(domain* D);
void executeDer2D(domain* D,fftwf_complex* p,fftwf_complex* p2,fftwf_plan planford,fftwf_plan planback,fftwf_plan planford2,fftwf_plan planback2,int N,float y,float y2);
void ricker_wavelet_tis0(domain* D,float dt,int nt,float t0,float f0,int l);
void System2D(domain* D);
void executeNablaLaplac1D(domain* D,fftwf_complex* p,fftwf_complex* p2,fftwf_plan planfordDer,fftwf_plan planbackDer,fftwf_plan planbackDer2,int N);
void CalcTerm1(domain* D);
void SetPandQ(domain* D);
void Parameters(domain* D);
#endif
