#include "pstd_opt.h"



void ricker_wavelet_tis0(domain* D,float dt,int nt,float t0,float f0,int l){

	D->source=(float*)malloc((D->nt)*sizeof(float));
	float B=0;float Pi;  Pi=3.141592654;
	B=Pi*Pi*f0*f0;
	if(l==0){
		for(int t=0;t<D->nt;t++){
			
            D->source[t]=100*((1-2*B*(t*D->Dt-t0)*(t*D->Dt-t0))*exp(-B*(t*D->Dt-t0)*(t*D->Dt-t0))); 
		}
	}
	

}




void source2D(domain* D,int type,int nS,int nR,int t){

	float aux;
    aux=0.0;
    
    for(int j=-1;j<2;j++){
        for(int i=-1;i<2;i++){	
            D->p[nS+i+j*D->nx]=D->source[t]*exp(-1*((i)*(i)+(j)*(j)))+D->p[nS+i+j*D->nx];
        }
    }
    
    
}


void initParam2D(domain* D,float Lx,float Ly,float Dx,float Dt, float S, float tiempo,int nPML,float sigma,float Abs){
	D->c=1510;
	
	D->S=D->c*Dt/Dx;
	D->Dx=Dx;
	D->nx=(int)(Lx/D->Dx)+nPML;
    D->ny=(int)(Ly/D->Dx)+nPML;
	D->sigma=sigma;
	D->nPML=nPML/2;
	D->nt=(int)(tiempo/Dt);
	D->Dt=Dt;	
	D->Abs=Abs;
    D->y=1.5;
   
}



void initArrays2D(domain* D){
	int nodes;
	nodes=D->nx*D->ny;	
	D->q=(float*)malloc((nodes)*sizeof(float));
	D->p=(float*)malloc((nodes)*sizeof(float));
    D->auxX=(float*)malloc((nodes)*sizeof(float));
    D->auxY=(float*)malloc((nodes)*sizeof(float));
	D->rho=(float*)malloc((nodes)*sizeof(float));
	D->vel=(float*)malloc((nodes)*sizeof(float));
    D->nu=(float*)malloc((nodes)*sizeof(float));
    D->tau=(float*)malloc((nodes)*sizeof(float));
	
	D->s.EUx=(int*)malloc((nodes)*sizeof(int));
    D->s.EUy=(int*)malloc((nodes)*sizeof(int));
	

	for(int i=0;i<nodes;i++){
		D->rho[i]=D->vel[i]=D->p[i]=D->q[i]=0.0;
		D->s.EUx[i]=0;
        D->s.EUy[i]=0;
	}
	

	
}



void defineDomain2D(domain* D,int type){
 int aux=0;
	for(int i=0;i<D->nx;i++){
        aux=0;
        for(int j=0;j<D->ny;j++){
				int node;
				node=i+j*D->nx;
				D->vel[node]=D->c;
				D->rho[node]=1;
                D->nu[node]=0.0;
                D->tau[node]=0.0;
				
				if(j>(int)((float)(D->ny/2))){
                    if(type==0){
                        D->vel[node]=2*D->c;
                    }
                    if(type==1){
                        D->rho[node]=2;
                        D->vel[node]=2*D->c;
                        
                    }
                    if(type==2){
                        D->rho[node]=2;
                        D->vel[node]=2*D->c;
                       
                        D->nu[node]=2*D->Abs*pow(D->vel[node],D->y)*tan(3.1415926*D->y/2);
                        D->tau[node]=-2*D->Abs*pow(D->vel[node],D->y-1);  
                        
                    }
                    
									
				}
				
				if(i<D->nPML){
					D->s.EUx[node]=D->nPML-i;
                
				}
				if(i>D->nx-1-D->nPML){
					D->s.EUx[node]=i-(D->nx-1-D->nPML);
				}

				if(i==0){//0
					D->s.EUx[node]=40;}
				if(i==D->nx-1){
					D->s.EUx[node]=40;}
				if(j<D->nPML){
					D->s.EUy[node]=D->nPML-j;
                
				}
				if(j>D->ny-1-D->nPML){
					D->s.EUy[node]=j-(D->ny-1-D->nPML);
				}

				if(j==0){//0
					D->s.EUy[node]=40;}
				if(j==D->ny-1){
					D->s.EUy[node]=40;}	
                
					
        }		
	}
	
	
}

void initDerivatives(domain* D){

	float pi=3.14159265358979323846;
	int N,N_2,p2;
	N=D->nx;
	if(N<D->ny)
        N=D->ny;
    if (N%2!=0)
        N=N+1;
    D->N=N;
	N_2=N/2+1;

	
	
	D->DerRx=(float *)malloc(N*sizeof(float));
    D->Derx=(fftwf_complex *)fftwf_malloc(N_2*sizeof(fftwf_complex));
	D->planfordDerx = fftwf_plan_dft_r2c_1d(N, D->DerRx, D->Derx, FFTW_ESTIMATE);
	D->planbackDerx = fftwf_plan_dft_c2r_1d(N, D->Derx, D->DerRx, FFTW_ESTIMATE);
    D->DerRy=(float *)malloc(N*sizeof(float));
    D->Dery=(fftwf_complex *)fftwf_malloc(N_2*sizeof(fftwf_complex));
	D->planfordDery = fftwf_plan_dft_r2c_1d(N, D->DerRy, D->Dery, FFTW_ESTIMATE);
	D->planbackDery = fftwf_plan_dft_c2r_1d(N, D->Dery, D->DerRy, FFTW_ESTIMATE);
    
	
    D->Der2Rx=(float *)malloc(N*sizeof(float));
	D->Der2x=(fftwf_complex *)fftwf_malloc(N_2*sizeof(fftwf_complex));
	D->planbackDer2x = fftwf_plan_dft_c2r_1d(N, D->Der2x, D->Der2Rx, FFTW_ESTIMATE);
    D->Der2Ry=(float *)malloc(N*sizeof(float));
	D->Der2y=(fftwf_complex *)fftwf_malloc(N_2*sizeof(fftwf_complex));
	D->planbackDer2y = fftwf_plan_dft_c2r_1d(N, D->Der2y, D->Der2Ry, FFTW_ESTIMATE);

    
   
	D->Der4=(fftwf_complex *)fftwf_malloc(N*N*sizeof(fftwf_complex));
	D->planfordDer4 = fftwf_plan_dft_2d(N,N, D->Der4, D->Der4,FFTW_FORWARD,FFTW_ESTIMATE);
	D->planbackDer4 = fftwf_plan_dft_2d(N,N, D->Der4, D->Der4, FFTW_BACKWARD,FFTW_ESTIMATE);
    
   
	D->Der5=(fftwf_complex *)fftwf_malloc(N*N*sizeof(fftwf_complex));
	D->planfordDer5 = fftwf_plan_dft_2d(N,N, D->Der5, D->Der5,FFTW_FORWARD, FFTW_ESTIMATE);
	D->planbackDer5 = fftwf_plan_dft_2d(N,N, D->Der5, D->Der5, FFTW_BACKWARD,FFTW_ESTIMATE);
    
	for(int i=0;i<N*N;i++){
        
        D->Der4[i][0]=D->Der4[i][1]=0.0;
        D->Der5[i][0]=D->Der5[i][1]=0.0;
        
        if(i<N_2){
            D->Derx[i][0]=D->Derx[i][1]=D->Der2x[i][0]=D->Der2x[i][1]=0.0;
            D->Dery[i][0]=D->Dery[i][1]=D->Der2y[i][0]=D->Der2y[i][1]=0.0;
        }
        if(i<N){
            D->DerRx[i]=D->Der2Rx[i]=0.0;
            D->DerRy[i]=D->Der2Ry[i]=0.0;
        }
	}
	
}


void executeDer2D(domain* D,fftwf_complex* p,fftwf_complex* p2,fftwf_plan planford,fftwf_plan planback,fftwf_plan planford2,fftwf_plan planback2,int N,float y,float y2){
    float Cte,Cte1,Cte2,CteT,theta,theta2;
    float pi=3.14159265358979323846;
    Cte=1.0/(N*N);
    
	fftwf_execute(planford);
    fftwf_execute(planford2);
    
	for(int i=0;i<N;i++){
        for(int j=0;j<N;j++){
            float aux1,aux2,aux3,aux4,aux5,aux6,aux7,aux8;
            theta=1;theta2=1;
            if(i<N/2-1)
                Cte2=2*pi*i/(N*D->Dx);
            else
                Cte2=-2*pi*(i-N)/(N*D->Dx);
            if(j<N/2-1)
                Cte1=2*pi*j/(N*D->Dx);
            else
                Cte1=-2*pi*(j-N)/(N*D->Dx);
            
            if((y<0)&&((i==0)&&(j==0))){
                theta=0;Cte1=1.0;Cte2=1.0;
                
            }
            if((y2<0)&&((i==0)&&(j==0))){
                theta2=0;Cte1=1.0;Cte2=1.0;
                
            }
            
            if((i==N/2-1)&&(j==N/2-1)){
                theta=0.0;theta2=0.0;
                Cte1=1.0;Cte2=1.0;
            }
            
            CteT=sqrt(Cte1*Cte1+Cte2*Cte2);
            /*if(CteT==0)
                printf("%lf %d %d %d %lf %lf\n",CteT,i,j,N,y,y2);*/
            aux1=theta*Cte*pow(CteT,y)*p[i+j*N][0];
            aux2=theta*Cte*pow(CteT,y)*p[i+j*N][1];
            aux3=theta2*Cte*pow(CteT,y2)*p2[i+j*N][0];
            aux4=theta2*Cte*pow(CteT,y2)*p2[i+j*N][1];
            p[i+j*N][0]=aux1;
            p[i+j*N][1]=aux2;
            p2[i+j*N][0]=aux3;
            p2[i+j*N][1]=aux4;
            
        }
    }

	fftwf_execute(planback);
    fftwf_execute(planback2);
    
        
   
}







void executeNablaLaplac1D(domain* D,fftwf_complex* p,fftwf_complex* p2,fftwf_plan planfordDer,fftwf_plan planbackDer,fftwf_plan planbackDer2,int N){
    float Cte,Cte2,theta;
    float pi=3.14159265358979323846;
    Cte=1.0/N;
    
	fftwf_execute(planfordDer);
	for(int i=0;i<N/2+1;i++){
		float aux1,aux2,aux3,aux4;
        Cte2=2*pi*i/(N*D->Dx);
        aux1=-Cte*Cte2*p[i][1];
        aux2=Cte*Cte2*p[i][0];
        aux3=-Cte*Cte2*Cte2*p[i][0];
        aux4=-Cte*Cte2*Cte2*p[i][1];
	
		p[i][0]=aux1;
		p[i][1]=aux2;
        p2[i][0]=aux3;
		p2[i][1]=aux4;
	}

	fftwf_execute(planbackDer);
    fftwf_execute(planbackDer2);
}

void Parameters(domain* D){
    int node,nodes;float sigma;
    nodes=D->nx*D->ny;
    D->C0=(float*)malloc((nodes)*sizeof(float));
    D->C1x=(float*)malloc((nodes)*sizeof(float));
    D->C1y=(float*)malloc((nodes)*sizeof(float));
    D->C2=(float*)malloc((nodes)*sizeof(float));
    D->C3=(float*)malloc((nodes)*sizeof(float));
    D->C4=(float*)malloc((nodes)*sizeof(float));
    D->intP=(int*)malloc((nodes)*sizeof(int));
        for(int i=0;i<D->nx;i++){
                for(int j=0;j<D->ny;j++){
                    node=i+j*D->nx;
                    if((D->s.EUx[node]!=40)&&(D->s.EUy[node]!=40)){
                            sigma=sqrt(D->s.EUx[node]*D->s.EUx[node]+D->s.EUy[node]*D->s.EUy[node])*D->sigma/(sqrt(2)*D->nPML);
                            D->C0[node]=1-sigma;
                            D->C1x[node]=D->Dt*D->vel[node]*D->vel[node]*(0.5*(D->rho[node+1]+D->rho[node-1])*(1.0/D->rho[node+1]-1.0/D->rho[node-1])/(2*D->Dx));
                            D->C1y[node]=D->Dt*D->vel[node]*D->vel[node]*(0.5*(D->rho[node+D->nx]+D->rho[node-D->nx])*(1.0/D->rho[node+D->nx]-1.0/D->rho[node-D->nx])/(2*D->Dx));
                            D->C2[node]=D->Dt*D->vel[node]*D->vel[node];
                            D->C3[node]=D->Dt*D->vel[node]*D->vel[node]*D->nu[node];
                            D->C4[node]=D->Dt*D->vel[node]*D->vel[node]*D->tau[node];
                            D->intP[node]=1;
                        
                    }
                    else{
                            D->C0[node]=0.0;
                            D->C1x[node]=0.0;
                            D->C1y[node]=0.0;
                            D->C2[node]=0.0;
                            D->C3[node]=0.0;
                            D->C4[node]=0.0;
                            D->intP[node]=0;
                        
                    }
                }
        }
    
}

void CalcTerm1(domain* D){
    
    int N;
    
    N=D->N;
   
    for(int l=0;l<2;l++){
        if(l==0){
            for(int j=0;j<D->ny;j++){
                for(int i=0;i<N;i++){
                    int node;float sigma;
                    node=i+j*D->nx;
                    if(i<D->nx)
                    D->DerRx[i]=D->p[node];
                    else
                    D->DerRx[i]=0.0;
                }
                executeNablaLaplac1D(D,D->Derx,D->Der2x,D->planfordDerx,D->planbackDerx,D->planbackDer2x,N);
                for(int i=0;i<D->nx;i++){
                    int node;float sigma;
                    node=i+j*D->nx;
                    D->auxX[node]=D->C0[node]*D->q[node]+D->C1x[node]*D->DerRx[i]+D->C2[node]*D->Der2Rx[i];
                }
            }
        }
        if(l==1){
            for(int i=0;i<D->nx;i++){
                for(int j=0;j<N;j++){
                    int node;
                    node=i+j*D->nx;
                    if(j<D->ny)
                        D->DerRy[j]=D->p[node];
                    else
                        D->DerRy[j]=0.0;
            
                }
                executeNablaLaplac1D(D,D->Dery,D->Der2y,D->planfordDery,D->planbackDery,D->planbackDer2y,N);
                for(int j=0;j<D->ny;j++){
                    int node;
                    node=i+j*D->nx;
                    D->auxY[node]=D->C1y[node]*D->DerRy[j]+D->C2[node]*D->Der2Ry[j];
                }
            }
        }
    }
}

void System2D(domain* D){
	
	
	int N;float sigma;
	N=D->N;
    
	for(int j=0;j<N;j++){
        for(int i=0;i<N;i++){
            int node,node2;
            node=i+j*N;
            node2=i+j*D->nx;
            D->Der4[node][1]=D->Der5[node][1]=0.0;
            if((i<D->nx)&&(j<D->ny)){
                D->Der4[node][0]=D->p[node2];
                D->Der5[node][0]=D->q[node2];
            }
            else
                D->Der4[node][0]=D->Der5[node][0]=0.0;
        }
    }
	executeDer2D(D,D->Der4,D->Der5,D->planfordDer4,D->planbackDer4,D->planfordDer5,D->planbackDer5,N,D->y+1,D->y);
    CalcTerm1(D);

	for(int j=0;j<D->ny;j++){
        for(int i=0;i<D->nx;i++){
            int node;
            node=i+j*D->nx;
            D->q[node]=D->auxX[node]+D->auxY[node]+D->C3[node]*D->Der4[i+j*N][0]+D->C4[node]*D->Der5[i+j*N][0];
            D->p[node]=D->intP[node]*(D->p[node]+D->Dt*D->q[node]);
        }
        
    }
	
}


void SetPandQ(domain* D){

    for (int i=0;i<D->nx*D->ny;i++){
            D->q[i]=D->p[i]=0.0;
        
    }
    
}

